LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY IFID_REG IS
        PORT(   SIGNAL DIN_Instruction          : IN    STD_LOGIC_VECTOR( 31 DOWNTO 0 );
                SIGNAL DIN_PC_plus_4_out        : IN    STD_LOGIC_VECTOR( 7 DOWNTO 0 );
                SIGNAL DOUT_Instruction         : OUT   STD_LOGIC_VECTOR( 31 DOWNTO 0 );
                SIGNAL DOUT_PC_plus_4_out       : OUT   STD_LOGIC_VECTOR( 7 DOWNTO 0 );
                SIGNAL clock, reset             : IN    STD_LOGIC);
END IFID_REG;


ARCHITECTURE behavior OF IFID_REG IS
BEGIN
        PROCESS
                BEGIN
                        WAIT UNTIL ( clock'EVENT ) AND ( clock = '1' );
						IF reset = '1' THEN
                        	DOUT_Instruction <= "00000000000000000000000000000000";
	                        DOUT_PC_plus_4_out <= "00000000";	
						ELSE
                        	DOUT_Instruction <= DIN_Instruction;
	                        DOUT_PC_plus_4_out <= DIN_PC_plus_4_out;
	
						END IF;
        END PROCESS;

END behavior;
